<?php

/**
 * Carerix Wordpress Plugin
 *
 * @category settings
 * @author Bogdan Ivanov
 * @copyright Copyright (c) 2013 Carerix.com (http://www.carerix.com)
 * @link http://www.carerix.com
 * @since Aug 29, 2013 1:08:16 PM
 * @version $Rev$
 */


/**
 * Job class
 * Used to ....
 */
class Entity_Cron_People extends Entity_Cron {
	
	public function getUrl() {
		$peopleUrl = Environment_Installation::get_people_feed();
		if(@$this->sourceData['settings']['feed'])
		{
			$peopleUrl .= '?'.$this->sourceData['settings']['feed'] ;
		}
		return $peopleUrl;
		
		return $this->sourceData['settings']['feed'];
	}

	public function process($data) {
        Utils_Cache::cleanEnvironment();
		$items = $data->channel->item;
		
		$itemsTable = $this->getArrayOfItems($items);
		
		$job = new Entity_Writer_People($itemsTable);
        $job->setIntroText(@$this->sourceData['settings']['introtext']);
		$job->setTitle($this->sourceData['name']);
		$job->setCorrespondentID($this->sourceData['id']);
		$id = $job->write();
        
        $this->interfacer->entity_set_property( $id, 
													'source', 
													$this->sourceData['id']);
		
	}
	
	private function getArrayOfItems($data)
	{
		$items = array();
		
		$collectors = array('pubDate', 'name', 'visitCity', 'users');
		
		foreach($data as $item)
		{
			$newItem = array();
			
			foreach($collectors as $collector)
			{
				if(isset($item->$collector))
				{
                    $name_collector = preg_replace('/\s+/u'  , ' | ',trim(strip_tags((string)$item->$collector)));
                    $name_collector = htmlentities($name_collector, null, 'utf-8');
                    $name_collector = str_replace('&nbsp;', '', $name_collector);
                    $name_collector = str_replace('&#160;', '', $name_collector); 
                    if(strlen($name_collector) == 0) continue;
                    
					switch($collector)
					{
						case 'users':
							$newItem[$collector] = (array)$item->$collector;
							
							if(   isset($newItem[$collector]['user']) 
							   && $newItem[$collector]['user'] !== NULL)
							{
								if(is_string($newItem[$collector]['user'])) 
								{
									continue;
								}
								
								if(is_object($newItem[$collector]['user']))
								{
									$newItem[$collector]['user'] = array(
										$newItem[$collector]['user']
									);
								}
							}
							break;
						default:
							$newItem[$collector] = (string)$item->$collector;
					}
				}
			}
			
			if(!empty($newItem)) array_push ($items, $newItem);
		}
		
		return $items;
	}
}